'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getRouteName = require('./getRouteName');

var _getRouteName2 = _interopRequireDefault(_getRouteName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (route, nameIfMissing) {
  var routeName = [];

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = route.schemes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var scheme = _step.value;

      var schemeName = scheme.props.name;
      if (scheme.props.view !== void 0) schemeName = (0, _getRouteName2.default)(scheme.props.view);
      if (schemeName) routeName.push(schemeName);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  routeName.push(route.name || nameIfMissing);
  return routeName.join('.');
};