'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getRouteName = require('./getRouteName');

var _getRouteName2 = _interopRequireDefault(_getRouteName);

var _getAbsoluteRouteName = require('./getAbsoluteRouteName');

var _getAbsoluteRouteName2 = _interopRequireDefault(_getAbsoluteRouteName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (route, name) {
  var view = route.component.props.view;
  var viewName = view ? (0, _getRouteName2.default)(view) : '';
  var absoluteViewName = (0, _getAbsoluteRouteName2.default)(route, viewName);
  var absoluteParts = absoluteViewName.split('.');
  absoluteParts.reverse();

  var tryName = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = absoluteParts[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var part = _step.value;

      tryName.unshift(part);
      if (tryName.join('.') === name) return true;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return false;
};