import React from 'react'
import shallowCompare from 'react-addons-shallow-compare'
import assign from 'lodash/assign'
import setDefinedOpt from 'opt-setter/setDefinedOpt'
import * as context from './context'
import bindEach from './bindEach'


export default class RouterContext extends React.Component {
  static childContextTypes = {
    router: React.PropTypes.object,
    route: React.PropTypes.object,
    history: React.PropTypes.object
  }

  getChildContext () {
    const history = context.historyContext
    const historyObj = this.props.history.toObject()
    setDefinedOpt(history, historyObj, false)
    bindEach(history, this.props.history)

    const router = assign({}, context.routerContext)
    setDefinedOpt(router, assign({}, history, this.props), false)
    router.onUpdate = history.onRouterUpdate

    const route = assign({}, context.routeContext, this.props.route)
    delete route.view

    return {router, route, history}
  }

  render () {
    return this.props.children
  }
}
