import getRouteName from './getRouteName';
import getAbsoluteRouteName from './getAbsoluteRouteName';

export default (function (route, name) {
  var view = route.component.props.view;
  var viewName = view ? getRouteName(view) : '';
  var absoluteViewName = getAbsoluteRouteName(route, viewName);
  var absoluteParts = absoluteViewName.split('.');
  absoluteParts.reverse();

  var tryName = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = absoluteParts[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var part = _step.value;

      tryName.unshift(part);
      if (tryName.join('.') === name) return true;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return false;
});